#       doinst_extract_links.bash
#       This file is part of zenpakt

#       Copyright 2011 Anshul Narula aka sunny <sunny_delhi18@yahoo.com>
#
#       Zenpakt is free software; you can redistribute it and/or modify
#       it under the terms of the GNU General Public License as published by
#       the Free Software Foundation; either version 2 of the License, or
#       (at your option) any later version.
#
#       This program is distributed in the hope that it will be useful,
#       but WITHOUT ANY WARRANTY; without even the implied warranty of
#       MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#       GNU General Public License for more details.
#
#       You should have received a copy of the GNU General Public License
#       along with this program; if not, write to the Free Software
#       Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston,
#       MA 02110-1301, USA.

######################
#REMOVED:
##local ln=0
##extract target of ln -sf
##remove all the quotings (files with newlines are not supported yet)
##remove quotes for cd dir ; rm quotes for cd dir for next line with ln ; rm quotes for ln target ; print dir
#println()
#{ #sed -n ' #/^( cd [^ ;]\+ ; rm -rf [^ ;]\+ )/ {
               #N ; #s/^( cd "\([^"][^ ;]*\)" ;/( cd \1 ;/
               #s/^( cd \(.*\) ; rm -rf \(.*\) )\n( cd "\1" ; ln -sf \([^ ;]\+\) \2 )/( cd \1 ; rm -rf \2 )\n( cd \1 ; ln -sf \3 \2 )/
               #s/^( cd \(.*\) ; rm -rf \(.*\) )\n( cd \1 ; ln -sf "\([^"][^ ;]\+\)" \2 )/( cd \1 ; rm -rf \2 )\n( cd \1 ; ln -sf \3 \2 )/
               #s/^( cd \(.*\) ; rm -rf \(.*\) )\n( cd \1 ; ln -sf \([^ ;]\+\) \2 )/\1\/\3/ p
               #}' "$1" | sort
#}
#########################

#HELP
#  meta_doinst_extract [-c] script
#  meta_doinst_extract [-D] [-c] /fullpath/script
#
#look if links.lists supported metadatabase was written, if so print a list of symlinks created from the database or else try to extract
#correctly from the ADM_DIR/scripts the symlinks created.In the latter case,look for consecutive lines of form ( cd dir ; rm -rf file ) and ( cd
#dir ; ln -sf file1 file ) in doinst and like scripts and extract the dir and file or file1 as specified.Always prints a null delimited output of
#file list
#
#OPTIONS
#   c     check if at least one link is listed
#   D     use the mass arguent as absolute path for doinst script; do not check for link list in any meta data
#
#ENDHELP
#------->CHANGE SCRIPTS USING THIS SOON <---------------
$$

#load builtin doinstxlinks and call it
doinstxlinks() {
  if enable_builtin doinstxlinks ; then
    unset -f doinstxlinks
    builtin doinstxlinks "$@"
  else
    doinstxlinks() { return 1 ;}
    return 1
  fi
}

#read from stdin a doinst file and output null delimited links list
doinst_extract_links_null() {
 doinst_extract_links | awk '{ printf("%s\0", $0); }'
}

doinst_extract_links() {
  sed -n '/^( cd [^ ;]\+ ; rm -rf [^ ;]\+ )/ {
     N
     s/^( cd "\([^"][^ ;]*\)" ; /( cd \1 ; /
     s/^( cd \(.*\) ; rm -rf "\([^"][^ )]*\)"/( cd \1 ; rm -rf \2/
     s,^( cd \(.*\) ; rm -rf \(.*\) )\n( cd "\?\1"\? ; ln -sf [^ ;]\+ "\?\2"\? ),\1/\2, p
  }'
}

#read given files and extract links from them
doinst_extract_links_null_f() {
  doinst_extract_links "$@" | awk '{ printf("%s\0", $0); }'
}

doinst_extract_links_f() {
  sed -n '/^( cd [^ ;]\+ ; rm -rf [^ ;]\+ )/ {
     N
     s/^( cd "\([^"][^ ;]*\)" ; /( cd \1 ; /
     s/^( cd \(.*\) ; rm -rf "\([^"][^ )]*\)"/( cd \1 ; rm -rf \2/
     s,^( cd \(.*\) ; rm -rf \(.*\) )\n( cd "\?\1"\? ; ln -sf [^ ;]\+ "\?\2"\? ),\1/\2, p
  }' "$@"
}

meta_doinst_extract()
{

  #check if database link lists are supported in given package meta database
  #return value of 1 --> no links are present
  #                2 --> links may be present but not in database, check the doinst script
  _db_chk_link_support_()
  {
  if ! grep -qx 'LINK LIST SUPPORTED: yes' "$ADM_DIR/packages/$1" ;then
    if grep -qx 'LINK LIST SUPPORTED: no' "$ADM_DIR/packages/$1" ;then
      return 1
    fi
    return 2
  fi
  return 0
  }

  #get links from the database entry
  #files will be null delimited,trailing newline after last \x00 should be ignored
  _db_getlinks_(){ sed -n '1!G;h;$p' "$ADM_DIR/scripts/$1" | sed '/^LINK LIST:$/,$d' ;}

  #extract symbolic links
  #remove all the quotings (files with newlines are not supported)
  #rm quotes for dir ; rm quotes for file removed ; match if next line is as required and print dir
  _doinst_printrm_()
  {
  awk '{ printf("%s", $0); }' < <( sed -n '/^( cd [^ ;]\+ ; rm -rf [^ ;]\+ )/ {
                 N
                 s/^( cd "\([^"][^ ;]*\)" ; /( cd \1 ; /
                 s/^( cd \(.*\) ; rm -rf "\([^"][^ )]*\)"/( cd \1 ; rm -rf \2/
                 s,^( cd \(.*\) ; rm -rf \(.*\) )\n( cd "\?\1"\? ; ln -sf [^ ;]\+ "\?\2"\? ),\1/\2, p
                 }' "$1"
            )
  }

  #check if at least 1 line with ( cd ; rm -rf ) and ( cd ; ln -sf ) is there ; if present produce a single line of output
  _doinst_printcheck_()
  {
     sed -n '
     /^( cd [^ ;]\+ ; rm -rf [^ ;]\+ )/ {
     N
     /( cd \(.*\) ; rm -rf \(.*\) )\n( cd \1 ; ln -sf [^ ;]\+ \2 )/ P
     q
     }' "$1"
  } 2>/dev/null

local _abs_=0 _chk_=0 _file_ OPTIND=1 REPLY || \
  { print -d"$FUNCNAME:possible readonly variables,trying to set local variables"; return 99;}

while getopts :Dc REPLY; do
  case $REPLY in
    D)
      _abs_=1
      ;;

    c)
      _chk_=1
      ;;
  esac
done

shift $((OPTIND-1))

# set the doinst file to use
[[ $1 ]] || { print -d"$FUNCNAME:no meta data name specified as \$1"; return 99;}

if ((_abs_));then
  [[ -f $1 ]] || { print -d"$FUNCNAME: doinst '$1' is not a file"; return 99;}
  #_file_=$1
else
  [[ $1 = */* ]] && \
    { print -d"$FUNCNAME:package name $1 is an absolute path and -D was not specified"; return 99 ;}
  _file_=( "$ADM_DIR"/scripts/"$1" )
fi

#check or print the links list
if ((_chk_));then
  if ((_abs_)) ;then
    [[ $(_doinst_printcheck_ "$1") ]]
  else
    if ! _db_chk_link_support_ "$1" ;then
      if (($? == 1)) ; then
        return 1
      else
        [[ $(_doinst_printcheck_ "$_file_") ]]
      fi
    fi
  fi

else
  if ((_abs_));then
    _doinst_printrm_ "$1"
  else
    if ! { _db_chk_link_support_ "$1" && _db_getlinks_ "$1" ;} ;then
      _doinst_printrm_ "$_file_"
    fi
  fi
fi
}
