#       enable_builtin.bash
#
#       This file is part of zenpakt

#       Copyright 2011 Anshul Narula aka sunny <sunny_delhi18@yahoo.com>
#
#       Zenpakt is free software; you can redistribute it and/or modify
#       it under the terms of the GNU General Public License as published by
#       the Free Software Foundation; either version 2 of the License, or
#       (at your option) any later version.
#
#       This program is distributed in the hope that it will be useful,
#       but WITHOUT ANY WARRANTY; without even the implied warranty of
#       MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#       GNU General Public License for more details.
#
#       You should have received a copy of the GNU General Public License
#       along with this program; if not, write to the Free Software
#       Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston,
#       MA 02110-1301, USA.

#HELP
#enable_builtin [-d] builtin
#
#enable the given BUILTIN using $SOURCE/builtins as directory to search for the loadable builtins
#if -d is given disable already loaded builtin
#ENDHELP
#=======================================================================#
$$
enable_builtin() {
  case $1 in
    -d)
      enable -d "$2"
      ;;
    *)
      enable -f "$ZENPAKT_BUILTINS_DIR/$1" "$1" || return 1
      ;;
  esac
} #2>/dev/null
