#       fullpath.bash
#       This file is part of zenpakt

#       Copyright 2011 Anshul Narula aka sunny <sunny_delhi18@yahoo.com>
#
#       Zenpakt is free software; you can redistribute it and/or modify
#       it under the terms of the GNU General Public License as published by
#       the Free Software Foundation; either version 2 of the License, or
#       (at your option) any later version.
#
#       This program is distributed in the hope that it will be useful,
#       but WITHOUT ANY WARRANTY; without even the implied warranty of
#       MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#       GNU General Public License for more details.
#
#       You should have received a copy of the GNU General Public License
#       along with this program; if not, write to the Free Software
#       Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston,
#       MA 02110-1301, USA.
#        zenpakt fullpath used by the scripts of zenpakt
#        Copyright 2010 Anshul Narula aka sunny <sunny_delhi18@yahoo.com>
#        see the COPYRIGHT file you should have received along with this script

##########
#  NEW fullpath
##########
$DOC
==========
 fullpath
==========

Synopsis
--------

fullpath file [variable]

Description
-----------

Try to guess the directory and cd to it and use $PWD.If cd fails, try using
non posix readlink(1).The directory must exist and must be cd-able

In case of an error , return a status of 1.
Default return variable is FULLPATH which is generally set to $1 in case of an
error

$ENDDOC

$$

fullpath() {

  local _fullpath_var=${2:-FULLPATH} _fullpath

  printf -v "$_fullpath_var" '%s' "$1"

  #If it ends in / or is an existing directory
  if [[ $1 = */ || -d $1 ]]; then
    if cd -- "$1" ; then
      _fullpath=${PWD%/}/
    else
      _fullpath=$(readlink -f "$1") || return 1
      _fullpath=${path%/}/
    fi

  elif [[ $1 = */* ]] ; then
    if cd -- "${1%/*}/" ; then
      _fullpath=${PWD%/}/${1##*/}
    else
      _fullpath=$(readlink -f "$1") || return 1
    fi

  else
    if cd -- ./ ; then
      _fullpath=${PWD%/}/$1
    else
      _fullpath=$(readlink -f "$1") || return 1
    fi

  fi

  printf -v "$_fullpath_var" '%s' "$_fullpath"

  cd "$OLDPWD"
}

