#       Source.bash
#
#       This file is part of Zenpakt

#       Copyright 2011 Anshul Narula aka sunny <sunny_delhi18@yahoo.com>
#
#       Zenpakt is free software; you can redistribute it and/or modify
#       it under the terms of the GNU General Public License as published by
#       the Free Software Foundation; either version 2 of the License, or
#       (at your option) any later version.
#
#       This program is distributed in the hope that it will be useful,
#       but WITHOUT ANY WARRANTY; without even the implied warranty of
#       MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#       GNU General Public License for more details.
#
#       You should have received a copy of the GNU General Public License
#       along with this program; if not, write to the Free Software
#       Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston,
#       MA 02110-1301, USA.

#TO DO:rename it to something less confusing (e.g include)

$DOC

=========
 include
=========

-------------------------------
 Source Zenpakt function files
-------------------------------

SYNOPSIS
--------

 **include** *file* [ *arg...* ]

DESCRIPTION
-----------

Source the given *file* using the value set by ZENPAKT_INCLUDE_DIR as the root
directory.Any more arguments are passed as argument to the file being sourced.

$ENDDOC

$$

include() {
  #if file is not readable or sourcing it failed, return 1
  [[ $ZENPAKT_INCLUDE_DIR && -r $ZENPAKT_INCLUDE_DIR/$1 ]] && \
    . "$ZENPAKT_INCLUDE_DIR/$1" "${@:2}" || return 1
}

#deprecated use include
Source(){
  print_v "zenpakt:***Source is deprecated, use include instead***"
  include "$@"
}
