#       lock.bash
#       This file is part of zenpakt

#       Copyright 2011 Anshul Narula aka sunny <sunny_delhi18@yahoo.com>
#
#       Zenpakt is free software; you can redistribute it and/or modify
#       it under the terms of the GNU General Public License as published by
#       the Free Software Foundation; either version 2 of the License, or
#       (at your option) any later version.
#
#       This program is distributed in the hope that it will be useful,
#       but WITHOUT ANY WARRANTY; without even the implied warranty of
#       MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#       GNU General Public License for more details.
#
#       You should have received a copy of the GNU General Public License
#       along with this program; if not, write to the Free Software
#       Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston,
#       MA 02110-1301, USA.

$DOC
======
 lock
======

Synopsis
--------

**lock** [ **-r** ]

Description
-----------

check lock ; if it doesnt exist acquire it.
fd 7 is used for lockfile and should not be used by calling scripts using this
function.

Options
-------

  -r  remove the lock

$ENDDOC

$$

lock() {
  local lock_dir=${ROOT%/}/var/lock

  case $1 in
    -r)
      exec 7>&-
      rm -f "$lock_dir"/zenpakt #remove the lock file
      ;;
    *)
      mkdir -p "$lock_dir"
      exec 7>"$lock_dir"/zenpakt || return 1
      flock -x -n 7 || return 1
      ;;
  esac

  return 0
} 2>/dev/null
