#       meta_getfilelist.bash
#       This file is part of zepakt

#       Copyright 2011 Anshul Narula aka sunny <sunny_delhi18@yahoo.com>
#
#       Zenpakt is free software; you can redistribute it and/or modify
#       it under the terms of the GNU General Public License as published by
#       the Free Software Foundation; either version 2 of the License, or
#       (at your option) any later version.
#
#       This program is distributed in the hope that it will be useful,
#       but WITHOUT ANY WARRANTY; without even the implied warranty of
#       MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#       GNU General Public License for more details.
#
#       You should have received a copy of the GNU General Public License
#       along with this program; if not, write to the Free Software
#       Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston,
#       MA 02110-1301, USA.


#HELP
#
#meta_getfilelist [-n] packagename
#
#print file list stored in the metadatabase of packagename.The database is
#usually written using output of tar-1.13 and therefore is probably
#in its default escaped quoting style and is newline delimited.If packagename doesnot contain any /'s then $ADM_DIR/packages is used to look
#for a valid metadatabase file, otherwise packagename is assumed to be the full path to the metadatabase.The output is NOT SORTED.
#
#OPTIONS:
#
#   n     produce file output null delimited; convert all the escape sequences into real filenames
#         not useful for printing, but helpful in scripts where you would be dealing with the actual files
#
#ENDHELP
$$

#The output produced by metaget -f would be more reliable if it was first
#unescaped first and then re-escaped by same function as used by unconvesc
#This way we can ensure same output as tar-1.13 and unconvesc on doinst_extract_links
#as done by removepkg_file_list_unique no matter which tar version was
#used to store the file list in meta database.
metaget() {
  if enable_builtin metaget ; then
    unset -f metaget
    builtin metaget "$@"
  else
    metaget() { return 1 ;}
    return 1
  fi
}
