#       mkfifo.bash
#       This file is part of zenpakt

#       Copyright 2011 Anshul Narula aka sunny <sunny_delhi18@yahoo.com>
#
#       Zenpakt is free software; you can redistribute it and/or modify
#       it under the terms of the GNU General Public License as published by
#       the Free Software Foundation; either version 2 of the License, or
#       (at your option) any later version.
#
#       This program is distributed in the hope that it will be useful,
#       but WITHOUT ANY WARRANTY; without even the implied warranty of
#       MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#       GNU General Public License for more details.
#
#       You should have received a copy of the GNU General Public License
#       along with this program; if not, write to the Free Software
#       Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston,
#       MA 02110-1301, USA.

#HELP
# fifo=$(mkfifo [dir|name])
#attempts to make a temporary unique fifo in $TMPDIR if no argument is provided ; if existing directory is passed as an argument ; fifo is made in that directory ; if first argument doesnot exist and doesnot contain or start with / , fifo is made including the argument in name with random numbers
#if first argument satisfies none of the above ,  then it returns 1
#ENDHELP
$$

mkfifo()
{
if [[ ! $mkfifo ]] ; then
  if chk_cmd mkfifo ; then
    mkfifo="mkfifo %s"
  elif chk_cmd mknod ; then
     mkfifo="mknod %s p"
  else
     return 1
  fi
  readonly mkfifo
fi
fifo_count=${fifo_count:=0} ; local fifo
if [[ $1 ]] ; then
  if [[ -d $1 && ! -h $1 ]] ; then
    fifo=$1/fifo.${RANDOM}${RANDOM}.$((fifo_count++))
  elif [[ ! -e $1 && ! -h $1 && $1 != @(*/*|/*) ]] ; then
    fifo=fifo.$1.${RANDOM}${RANDOM}
  else
    return 1
  fi
else
   fifo=$TMPDIR/fifo.$RANDOM$RANDOM.$((fifo_count++))
fi
rm -rf "$fifo" && command $(printf "$mkfifo" "$fifo" ) || return 1
printf "%s\n" "$fifo"
}
