#       pkg_geturlpkg.bash
#       This file is part of zenpakt
#
#       Copyright 2010 Anshul Narula aka sunny <sunny_delhi18@yahoo.com>
#
#       Zenpakt is free software; you can redistribute it and/or modify
#       it under the terms of the GNU General Public License as published by
#       the Free Software Foundation; either version 2 of the License, or
#       (at your option) any later version.
#
#       This program is distributed in the hope that it will be useful,
#       but WITHOUT ANY WARRANTY; without even the implied warranty of
#       MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#       GNU General Public License for more details.
#
#       You should have received a copy of the GNU General Public License
#       along with this program; if not, write to the Free Software
#       Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston,
#       MA 02110-1301, USA.


$DOC
pkg_geturlpkg urlpkg
uses internal wfetch() relying only on bash's tcp support and cat,stat or wc if present allow a progress to be printed on the stderr
wfetch respects VERBOSE and so does pkg_geturlpkg
RETURN STATUS:
    1    failed to open tcp socket or connect to given server
    2    asked to redirect, but no Location header
    3    could not determine size on server
    4    number of redirections on http server exceeded the maximum allowed
    5    file fully retreived but asked to continue
    6    error writing to the said out file
    7    file could not be downloaded completely(not used currently), and continue not supported
    8    error response from server failed to download
    9    failed to do anonymous login to ftp server
    10   failed to change directory (ftp)
    11   failed to change to binary mode(ftp)
    12   failed to pasv or open data connection
    99   unknown option ; should not occur
$ENDDOC
'
$$

pkg_geturlpkg() {
  pkg_urlpkg=
  ( cd "$TMPDIR" && wfetch "$1" ) || return $?
  pkg_urlpkg="$wfetch_ofile"
}
