#       pkg_cis_file_or_url.bash
#       This file is part of zenpakt

#       Copyright 2010 Anshul Narula aka sunny <sunny_delhi18@yahoo.com>
#
#       Zenpakt is free software; you can redistribute it and/or modify
#       it under the terms of the GNU General Public License as published by
#       the Free Software Foundation; either version 2 of the License, or
#       (at your option) any later version.
#
#       This program is distributed in the hope that it will be useful,
#       but WITHOUT ANY WARRANTY; without even the implied warranty of
#       MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#       GNU General Public License for more details.
#
#       You should have received a copy of the GNU General Public License
#       along with this program; if not, write to the Free Software
#       Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston,
#       MA 02110-1301, USA.

$DOC

====================
 pkg_is_file_or_url
====================

Synopsis
--------
**pkg_is_file_or_url** *package* [ *variable* ]

Description
-----------

checks for existence of package and determines wether it is a file or url and
sets $pkg_pkgtype to url or file accordingly.First check if it is a file, if not,
if it starts with http:// or ftp:// it is considered as url.The type is stored in
variable if given.In case none of conditions are met with nonzero value is returned.

$ENDDOC

$$

pkg_is_file_or_url() {
  if [[  -f $1 ]]; then
    [[ $2 ]] && printf -v "$2" 'file'

  elif [[ $1 = @(http://*|ftp://*) ]]; then
    [[ $2 ]] && printf -v "$2" 'url'

  else
    return 1
  fi

  return 0
}
