#       Copyright 2010 Anshul Narula aka sunny <sunny_delhi18@yahoo.com>
#
#       This file is part of zenpakt

#       Zenpakt is free software; you can redistribute it and/or modify
#       it under the terms of the GNU General Public License as published by
#       the Free Software Foundation; either version 2 of the License, or
#       (at your option) any later version.
#
#       This program is distributed in the hope that it will be useful,
#       but WITHOUT ANY WARRANTY; without even the implied warranty of
#       MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#       GNU General Public License for more details.
#
#       You should have received a copy of the GNU General Public License
#       along with this program; if not, write to the Free Software
#       Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston,
#       MA 02110-1301, USA.

$DOC

=======
 print
=======

SYNOPSIS
--------

printf_v format arg...

echo_v arg...
echon_v arg...

print_v arg...
print arg...

DESCRIPTION
-----------
printf_v is like printf but output is produced only if VERBOSE is non-zero.

echo_v is like echo but output is produced only if VERBOSE is non-zero.

echon_v is like echo -n but output is produced only if VERBOSE is non-zero

print_v is like printf '%s\n' but output is produced only if VERBOSE is non-zero

print is like printf '%s\n'

RETURN STATUS
-------------

return value is non-zero if VERBOSE is zero except for print.Otherwise, return
value is the return status of printf

$ENDDOC

$$

#printf if verbose is nonzero
printf_v() { ((VERBOSE)) && printf "$@" ;}

#echo if VERBOSE is nonzero
echo_v() { ((VERBOSE)) && printf '%s\n' "$*" ;}

#echo -n if VERBOSE is nonzero
echon_v() { ((VERBOSE)) && printf '%s' "$*" ;}

#print with '%s\n' as format if verbose is nonzero
print_v() { ((VERBOSE)) && printf '%s\n' "$@" ;}

#print with '%s\n' as format even if verbose is zero
print() { printf '%s\n' "$@" ;}
