#       Copyright 2010 Anshul Narula aka sunny <sunny_delhi18@yahoo.com>
#
#       This file is part of zenpakt

#       Zenpakt is free software; you can redistribute it and/or modify
#       it under the terms of the GNU General Public License as published by
#       the Free Software Foundation; either version 2 of the License, or
#       (at your option) any later version.
#
#       This program is distributed in the hope that it will be useful,
#       but WITHOUT ANY WARRANTY; without even the implied warranty of
#       MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#       GNU General Public License for more details.
#
#       You should have received a copy of the GNU General Public License
#       along with this program; if not, write to the Free Software
#       Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston,
#       MA 02110-1301, USA.

#NOTE
#  uses new print() and yet unimplemented -d flag for debugging
#HELP
#putline [-c char][-v] [-l length]
# draw a line of length specified by -l or a length equal to $COLUMNS if it is set, if none return 1
#
#OPTIONS:
#   l length length
#   v        vital mode, print regardless of VERBOSE is zero
#   c char   use character to draw the line instead of default _, using this option combined with l you can print repeated characters as you
#            and when you want
#   n        suppress trailing newline
#ENDHELP
$$
putline()
{
OPTIND=0
local char=_ vital=0 length=$COLUMNS l f='%s\n'
while getopts :c:vnl: REPLY; do
  case $REPLY in
    c)
      char=$OPTARG
      ;;
    v)
      vital=1
      ;;
    l)
      ((length=$OPTARG))
      ;;
    \?)
      print -d "invalid option -$OPTARG"
      return 1
      ;;
    :)
      print -d "option -$OPTARG requires an argument"
      return 1
      ;;
    n)
      f='%s'
      ;;
  esac
done
shift $((OPTIND-1))
((length)) || return 1
printf -v l '%*s' $length
if ((vital)) ; then
  printf "$f" "${l// /$char}"
else
  print -f "$f" "${l// /$char}"
fi
}
