#       Copyright 2010 Anshul Narula aka sunny <sunny_delhi18@yahoo.com>
#
#       This file is part of zenpakt

#       Zenpakt is free software; you can redistribute it and/or modify
#       it under the terms of the GNU General Public License as published by
#       the Free Software Foundation; either version 2 of the License, or
#       (at your option) any later version.
#
#       This program is distributed in the hope that it will be useful,
#       but WITHOUT ANY WARRANTY; without even the implied warranty of
#       MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#       GNU General Public License for more details.
#
#       You should have received a copy of the GNU General Public License
#       along with this program; if not, write to the Free Software
#       Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston,
#       MA 02110-1301, USA.

$DOC

==========
 terminfo
==========

SYNOPSIS
--------

col_fg [black] [red] [green] [cyan] [blue] [magenta] [yellow] [grey] [white] [default]

col_bg [black] [red] [green] [cyan] [blue] [magenta] [yellow] [grey] [white] [default]

txt_attrib [reset] [bold] [dim] [uline] [rmuline] [hidden] [blink] [reverse]

columns

lines

DESCRIPTION
-----------

col_bg and col_fg store ANSI background and foreground colors respectively in
variables that start with COL\_ or COLB\_ and ends with the given color name.
\`col_fg black\` , for example, stores code for black color in COL_black.

txt_attrib stores the given txt attributes in variables that start with TXT\_
and end with the attribute argument name.

columns and lines set the COLUMNS and LINES variable to their respective
values.

$ENDDOC

$$

#get fg colors
#col_fg args
col_fg() {
  local black=0 red=1 green=2 yellow=3 blue=4 magenta=5 cyan=6 grey=7 white=8 \
    default=9 arg

  for arg do
    case $arg in
      black|red|green|yellow|blue|magenta|cyan|grey|white|default)
        eval readonly COL_"$arg"=$(tput setaf "${!arg}" || tput AF "${!arg}")
        ;;
    esac
  done
} 2>/dev/null

#col_bg args
col_bg(){
  local black=0 red=1 green=2 yellow=3 blue=4 magenta=5 cyan=6 grey=7 white=8 \
    default=9 arg

  for arg do
    case $arg in
      black|red|green|yellow|blue|magenta|cyan|grey|white|default)
        eval readonly COLB_"$arg"=$(tput setab "${!arg}" || tput AB "${!arg}")
        ;;
    esac
  done
} 2>/dev/null

columns() {
  COLUMNS=80
  COLUMNS=$(tput cols)
  ((COLUMNS == -1 )) && COLUMNS=80
}  2>/dev/null

lines() {
  LINES=
  LINES=$(tput lines)
  ((LINES == -1))  && LINES=
}  2>/dev/null

txt_attrib() {
  local reset=sgr0      bold=bold     dim=dim         uline=smul \
        reset_tcap=me   bold_tcap=md  dim_tcap=mh     uline_tcap=us \
        rmuline=rmul    blink=blink   reverse=rev     hidden=invis \
	rmuline_tcap=ue blink_tcap=mb reverse_tcap=mr hidden_tcap=mk


  for arg do
    case $arg in
      reset|bold|dim|uline|rmuline|blink|reverse|hidden)
        eval readonly TXT_"$arg"=\"$(tput "${!arg}" || tput "${!arg}_tcap")\"
        ;;
    esac
  done
} 2>/dev/null

