#        Copyright 2011 Anshul Narula aka sunny <sunny_delhi18@yahoo.com>
#
#       This file is part of zenpakt

#       Zenpakt is free software; you can redistribute it and/or modify
#       it under the terms of the GNU General Public License as published by
#       the Free Software Foundation; either version 2 of the License, or
#       (at your option) any later version.
#
#       This program is distributed in the hope that it will be useful,
#       but WITHOUT ANY WARRANTY; without even the implied warranty of
#       MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#       GNU General Public License for more details.
#
#       You should have received a copy of the GNU General Public License
#       along with this program; if not, write to the Free Software
#       Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston,
#       MA 02110-1301, USA.

$DOC
========
 assert
========

SYNOPSIS
--------

**assert** *command* *arg* ...

DESCRIPTION
-----------

assert evals the command and if the exit/return status is non-zero calls
`die <die.html>`_ with the message `FILE NAME: LINENO: FUNCNAME: Assertion
'command'(args) failed`. `arg` is not part of the command which is eval\'d but
may be useful in some cases as given below.

Please note that assert is a function which calls eval so if you pass a positional
parameter unexpanded it will be expanded as the positional parameter of assert and
not of the caller.So::

  assert '[[ -f $1 ]]'

will expand to::

  assert '[[ -f ]]' #since $1 is not set

As a workaround you can expand $1 while calling assert and let eval act on
expanded result.This is dangerous if you are not sure what $1 contains::

  assert "[[ -f $1 ]]" #dangerous, what if $1 was "file ]] ; rm -rf /"

Or you can make use of positional parameter to assert::

  assert '[[ -f $2 ]]' "$1" #safe

$ENDDOC

$$

#eval the given argument and if it does not return true call die
#Do not give it a variable set by a user as it calls eval--check it yourself.
#You should
#assert command $LINENO $BASH_SOURCE
assert() {
  eval "$1" ||
  die "${BASH_SOURCE[1]}: $BASH_LINENO: ${FUNCNAME[1]}: Assertion '$1'(${@}) arg failed"
}
