#        Copyright 2011 Anshul Narula aka sunny <sunny_delhi18@yahoo.com>
#
#       This file is part of zenpakt

#       Zenpakt is free software; you can redistribute it and/or modify
#       it under the terms of the GNU General Public License as published by
#       the Free Software Foundation; either version 2 of the License, or
#       (at your option) any later version.
#
#       This program is distributed in the hope that it will be useful,
#       but WITHOUT ANY WARRANTY; without even the implied warranty of
#       MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#       GNU General Public License for more details.
#
#       You should have received a copy of the GNU General Public License
#       along with this program; if not, write to the Free Software
#       Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston,
#       MA 02110-1301, USA.

$DOC
==============
 debug_xtrace
==============

SYNOPSIS
--------

debug_xtrace_on [fd]
debug_xtrace_off

DESCRIPTION
-----------

debug_xtrace_on sets PS4 and then calls set -x.If fd is given sets BASH_XTRACEFD
to fd.

debug_xtrace_off unsets BASH_XTRACEFD and thus closes the associated fd, resets PS4
to + and calls set +x

$ENDDOC

$$

#debug_xtrace_on [fd]
debug_xtrace_on() {
  if [[ $1 = [3-9] ]] ; then
    BASH_XTRACEFD=$1
  fi
  export PS4='+$BASH_SOURCE: $LINENO: ${FUNCNAME:+$FUNCNAME(): }'
  set -x
}

debug_xtrace_off() {
  set +x
  unset BASH_XTRACEFD
  PS4=+
}
