#        Copyright 2011 Anshul Narula aka sunny <sunny_delhi18@yahoo.com>
#
#       This file is part of zenpakt

#       Zenpakt is free software; you can redistribute it and/or modify
#       it under the terms of the GNU General Public License as published by
#       the Free Software Foundation; either version 2 of the License, or
#       (at your option) any later version.
#
#       This program is distributed in the hope that it will be useful,
#       but WITHOUT ANY WARRANTY; without even the implied warranty of
#       MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#       GNU General Public License for more details.
#
#       You should have received a copy of the GNU General Public License
#       along with this program; if not, write to the Free Software
#       Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston,
#       MA 02110-1301, USA.

$DOC
============
 stacktrace
============

SYNOPSIS
--------

stacktrace

DESCRIPTION
-----------

print a stacktrace by calling builtin caller.(Its possible by using BASH_LINENO,
BASH_SOURCE and FUNCNAME arrays too).

$ENDDOC
$$

#print a stack trace
#usually called by die before exiting due to an internal error.
stacktrace() {
  local frame=0
  debug_msg "====StackTrace==="
  debug_msg "$BASH version: $BASH_VERSION"
  debug_msg "Zenpakt version: $ZENPAKT_VERSION"
  debug_msg "Program Name: $ZENPAKT_PROG_NAME"
  debug_msg ""
  debug_msg "(line subroutine filename)"
  while caller $frame; do
    ((frame++));
  done >&2
  debug_msg "================"
}
