#       Copyright 2010 Anshul Narula aka sunny <sunny_delhi18@yahoo.com>
#
#       This file is part of zenpakt

#       Zenpakt is free software; you can redistribute it and/or modify
#       it under the terms of the GNU General Public License as published by
#       the Free Software Foundation; either version 2 of the License, or
#       (at your option) any later version.
#
#       This program is distributed in the hope that it will be useful,
#       but WITHOUT ANY WARRANTY; without even the implied warranty of
#       MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#       GNU General Public License for more details.
#
#       You should have received a copy of the GNU General Public License
#       along with this program; if not, write to the Free Software
#       Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston,
#       MA 02110-1301, USA.

$$

#Global variable used to store the location of tar ball used for backup
_installpkg_bkup_tar=

installpkg_bkup() {

  #Create a temporary file for backup tar ball
  mktemp _installpkg_bkup_tar || return "$ERR_CREAT_TMP"

  set -o pipefail

  #package compression basename
  #create the backup for the file list
  #and package database
  {
    [[ -f $ADM_DIR/packages/$3 ]] && printf '%s\0' "var/log/packages/$3"
    [[ -f $ADM_DIR/scripts/$3 ]] && printf '%s\0' "var/log/scripts/$3"
    pkg_file_list DI "$1" "$2" | convesc || return 1
  } | bkup "$_installpkg_bkup_tar" "$ROOT" || {
    set +o pipefail
    return "$ERR_BKUP"
  }

  set +o pipefail

  rm -f "$ADM_DIR/packages/$3" >/dev/null 2>&1
  rm -f "$ADM_DIR/scripts/$3" >/dev/null 2>&1

}

installpkg_bkup_restore() {
  restore "$_installpkg_bkup_tar" "$ROOT"
  installpkg_bkup_rm
}

installpkg_bkup_rm () {
  rm "$_installpkg_bkup_tar"
  _installpkg_bkup_tar=
}

installpkg_bkup_exists () {
  [[ $_installpkg_bkup_tar && -f $_installpkg_bkup_tar ]]
}

installpkg_bkup_basename () {
  die "***DEPRECATED: installpkg_bkup_basename is deprecated, use installpkg_state_basename or upgradepkg_state_basename instead"
}
