#       Copyright 2010 Anshul Narula aka sunny <sunny_delhi18@yahoo.com>
#
#       This file is part of zenpakt

#       Zenpakt is free software; you can redistribute it and/or modify
#       it under the terms of the GNU General Public License as published by
#       the Free Software Foundation; either version 2 of the License, or
#       (at your option) any later version.
#
#       This program is distributed in the hope that it will be useful,
#       but WITHOUT ANY WARRANTY; without even the implied warranty of
#       MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#       GNU General Public License for more details.
#
#       You should have received a copy of the GNU General Public License
#       along with this program; if not, write to the Free Software
#       Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston,
#       MA 02110-1301, USA.

#HELP
#installpkg_configure package [bkupdir]
#requires $installpkg_bkup_dir, $ADM_DIR and $ROOT to be set as a proper directory
#first checks if bkupdir is given, if given tries to create the directory if it doesnt exist and uses it as backup directory
#else if $installpkg_bkup_dir is set(mostly set if installpkg_install is used prior to it) and is a directory, use it as bkup directory
#else make its own backup direcory
# 1: error copying installation script to scripts dir
# 2: error executing doinst
# 3: failed to extract doinst.sh
#ENDHELP
#FIXME: use the filelist generated by successful installpkg_install, as this function is called after installpkg_install

installpkg_configure package compression basename
$$

installpkg_configure() {

  #configure newly installed libraries
  [[ -x /sbin/ldconfig ]] &&  /sbin/ldconfig >/dev/null 2>&1

  local _installpkg_configure_tscript _installpkg_configure_return=0

  #create a temporary file to store the script
  mktemp _installpkg_configure_tscript

  #temporarily extract doinst.sh to stdout and write it to temp file and
  #also pass it as stdin to shell
  #If error occurs while executing commands of doisnt.sh, return nonzero
  if "$2" -dc "$1" | tar -tf - install/doinst.sh >/dev/null 2>&1; then
    "$2" -dc "$1" |
    tar -xOf - install/doinst.sh 2>/dev/null |
    tee "$_installpkg_configure_tscript" |
    execute "$ROOT" -s -- -install ||
    _installpkg_configure_return=$ERR_EXEC_DOINST

    if mv "$_installpkg_configure_tscript" "$ADM_DIR/scripts/$3"; then
      chmod 755 "$ADM_DIR/scripts/$3"
    else
      _installpkg_configure_return=$ERR_CP_DOINST
    fi

    rm -f "$_installpkg_configure_tscript"
  fi

  return "$_installpkg_configure_return"
}
