#       Copyright 2010 Anshul Narula aka sunny <sunny_delhi18@yahoo.com>
#
#       This file is part of zenpakt

#       Zenpakt is free software; you can redistribute it and/or modify
#       it under the terms of the GNU General Public License as published by
#       the Free Software Foundation; either version 2 of the License, or
#       (at your option) any later version.
#
#       This program is distributed in the hope that it will be useful,
#       but WITHOUT ANY WARRANTY; without even the implied warranty of
#       MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#       GNU General Public License for more details.
#
#       You should have received a copy of the GNU General Public License
#       along with this program; if not, write to the Free Software
#       Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston,
#       MA 02110-1301, USA.

$DOC

==================
 installpkg_state
==================

SYNOPSIS
--------

installpkg_state_start basename

installpkg_state_end

installpkg_state

installpkg_state_basename

DESCRIPTION
-----------

installpkg_state_start sets the value of a global internal variable to zero.The
value of this variable by default is 1.

installpkg_state_end after a call to installpkg_state_start can be used to reset
the value back to 1.

These two are used to set the state to zero before any install and it is set back
to 1 after a successful or unsuccessful install.

The use of these function is that by finding the state at exit we can find out if
we were interrupted during the installation.If we were, we should restore from
backup and move the database index to partial_packages and remove the doinst
script if it was already stored in the scripts directory.

$ENDDOC

$$

_installpkg_state=1
_installpkg_state_basename=

installpkg_state_start() {
  assert '[[ $4 ]]' $LINENO $BASH_SOURCE "$1"
  _installpkg_state=0
  _installpkg_state_basename=$1
}

installpkg_state_end() {
  _installpkg_state=1
  _installpkg_state_basename=
}

installpkg_state() {
  return "$_installpkg_state"
}

installpkg_state_basename() {
  printf -v "$1" '%s' "$_installpkg_state_basename"
}
