#       Copyright 2010 Anshul Narula aka sunny <sunny_delhi18@yahoo.com>
#
#       This file is part of zenpakt

#       Zenpakt is free software; you can redistribute it and/or modify
#       it under the terms of the GNU General Public License as published by
#       the Free Software Foundation; either version 2 of the License, or
#       (at your option) any later version.
#
#       This program is distributed in the hope that it will be useful,
#       but WITHOUT ANY WARRANTY; without even the implied warranty of
#       MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#       GNU General Public License for more details.
#
#       You should have received a copy of the GNU General Public License
#       along with this program; if not, write to the Free Software
#       Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston,
#       MA 02110-1301, USA.

$$

makepkg_link_exists() {
  local link
  link=$(find . -type l -print -quit) && [[ $link ]]
}

makepkg_link_create_script() {
  printf '# %s\n' "Link Creation Code added by Zenpakt makepkg on $(date)"
  find . -type l \( \
    \( \
      -path '*'''$'\n''*' \
      -exec \
      "$BASH" -c 'printf "WARNING: skipped symbolic link with newlines: %s\n" "$1" >&2' \
      _ {} \; \
    \) -o \( \
      -printf '( cd "%h" ; rm -rf "%f" )\n( cd "%h" ; ln -sf "%l" "%f" )\n' \
      -exec rm -f {} \; \
    \) \
  \)
  printf '# %s\n' "End Link Creation Code"
}

makepkg_link_add() {
  if makepkg_link_exists ; then
    if [[ -f install/doinst.sh ]] ; then
      if ((MAKEPKG_PREPEND)) ; then
	local doinst_tmp
	mktemp doinst_tmp || return "$ERR_CREAT_TMP"

	set -o pipefail

	makepkg_link_create_script | cat - install/doinst.sh > "$doinst_tmp" || {
	  set +o pipefail
	  return "$ERR_CREAT_DOINST"
        }

	set +o pipefail

	mv "$doinst_tmp" install/doinst.sh || return "$ERR_CREAT_DOINST"

      else
        makepkg_link_create_script >> install/doinst.sh || return "$ERR_CREAT_DOINST"
      fi

    else
      makepkg_link_create_script > install/doinst.sh || return "$ERR_CREAT_DOINST"
    fi
  fi
}
