#       Copyright 2010 Anshul Narula aka sunny <sunny_delhi18@yahoo.com>
#
#       This file is part of zenpakt

#       Zenpakt is free software; you can redistribute it and/or modify
#       it under the terms of the GNU General Public License as published by
#       the Free Software Foundation; either version 2 of the License, or
#       (at your option) any later version.
#
#       This program is distributed in the hope that it will be useful,
#       but WITHOUT ANY WARRANTY; without even the implied warranty of
#       MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#       GNU General Public License for more details.
#
#       You should have received a copy of the GNU General Public License
#       along with this program; if not, write to the Free Software
#       Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston,
#       MA 02110-1301, USA.

$$
makepkg_parseargs() {

  local getargs

  getargs=(
    l  linkadd  :  1
    c  chown    :  1
    p  prepend  -  1
  )

  makepkg_parseargs() {
    case $2 in
      l|linkadd)
        if [[ $3 = y ]] ; then
          MAKEPKG_LINKADD=1
        elif [[ $3 = n ]] ; then
          MAKEPKG_LINKADD=0
        else
          error_print "$1$2: invalid argument: $3"
          return 1
        fi
        ;;

      c|chown)
        if [[ $3 = y ]] ; then
          readonly MAKEPKG_CHOWN=1
        elif [[ $3 = n ]] ; then
          readonly MAKEPKG_CHOWN=0
        else
          error_print "$1$2: invalid argument: $3"
        fi
        ;;

      p|prepend)
        MAKEPKG_PREPEND=1
        ;;

      version)
        version 'GPL2+'
        exit 0
        ;;

      help)
        usage 0 makepkg
        exit 0
        ;;
    esac
  }

  #In case there is an error in option parsing or mass argument is not exactly
  #one
  if ! getargs makepkg_parseargs "$@" || ((GETARGS_IND != $#)); then
    usage 1
    return 1
  fi

  readonly MAKEPKG_LINKADD MAKEPKG_PREPEND
  return 0
}
