#       Copyright 2010 Anshul Narula aka sunny <sunny_delhi18@yahoo.com>
#
#       This file is part of zenpakt

#       Zenpakt is free software; you can redistribute it and/or modify
#       it under the terms of the GNU General Public License as published by
#       the Free Software Foundation; either version 2 of the License, or
#       (at your option) any later version.
#
#       This program is distributed in the hope that it will be useful,
#       but WITHOUT ANY WARRANTY; without even the implied warranty of
#       MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#       GNU General Public License for more details.
#
#       You should have received a copy of the GNU General Public License
#       along with this program; if not, write to the Free Software
#       Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston,
#       MA 02110-1301, USA.

$$

removepkg_cleanup() {

  #In case removepkg_bkup_and_remove_files was called and not finished
  #the returned value will be zero or else it will be 1.
  #So if it was called and we were sent SIGTERM or SIGINT we can restore.
  if removepkg_bkup_and_remove_files_state ; then
    removepkg_bkup_restore

  #Or in case moving the database failed we need to restore the files and the
  #databse.Again we could look at the exit status too.
  elif removepkg_move_dbentry_status ; then
    removepkg_bkup_restore
    removepkg_unmove_dbentry

  #In case we were interrupted between a call to removepkg_bkup_and_remove_files
  #removepkg_move_dbentry where removepkg_bkup_files finished and the latter
  #didn't even start, both above functions may return false.But we still need
  #to restore.We just call the two functions, they will return in case their
  #respective required files don't exist.
  #As such, the above two tests would'nt be necessary as this function
  #would return the state for the completion or non completion of the above two
  #steps in case of an interruption or exit.We retain them for now and would
  #remove them after some more testing.
  elif removepkg_state ; then
    removepkg_bkup_restore
    removepkg_unmove_dbentry

  fi

  spin_inactive || spin_msg_error

  meta_rm_tmpdir

  local exit_status
  error_exit_status exit_status
  ((error_exit_status == $ERR_LOCKED)) || lock -r
}
