#       Copyright 2010 Anshul Narula aka sunny <sunny_delhi18@yahoo.com>
#
#       This file is part of zenpakt

#       Zenpakt is free software; you can redistribute it and/or modify
#       it under the terms of the GNU General Public License as published by
#       the Free Software Foundation; either version 2 of the License, or
#       (at your option) any later version.
#
#       This program is distributed in the hope that it will be useful,
#       but WITHOUT ANY WARRANTY; without even the implied warranty of
#       MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#       GNU General Public License for more details.
#
#       You should have received a copy of the GNU General Public License
#       along with this program; if not, write to the Free Software
#       Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston,
#       MA 02110-1301, USA.

removepkg_file_list_unique package...

$$

_removepkg_file_list_common=

removepkg_file_list_unique() {

  local glob i list_pkg list_others REPLY files

  #make a temporary file to store the list of files and symlinks from all
  #packages except those to be removed
  mktemp list_others || return "$ERR_CREAT_TMP"

  #create an extended glob pattern to get list of all packages except those to
  #be removed.This is faster than using an inarray loop inside a for loop.
  printf -v glob '%q|' "$@"
  glob=${glob%|}

  trap 'set +o pipefail ; shopt -u nullglob' RETURN
  set -o pipefail
  shopt -s nullglob

  #It is better to obtain unescaped version of file list and symbolic links list
  #so that sort -u can be done more reliably, e.g. \t in escaped and unescaped
  #files represent two different things.As a result of which we use comm0 instead
  #of comm
  #Another approach possible is to convert doinst links into escaped newline
  #delimited list and use comm and reconvert files back into unescaped version
  #for removal.(We use the second approach right now)
  {
    files=("$ADM_DIR"/packages/!($glob))
    if ((${#files[@]})) ; then
      metaget -f "${files[@]}" || return 1
    fi
    files=("$ADM_DIR"/scripts/!($glob))
    if ((${#files[@]})) ; then
      doinstxlinks "${files[@]}" || return 1
    fi
  } | sort -u > "$list_others" || return "$ERR_META_FETCH_FILE_LIST"

  #create a temporary file to store the list of files for given packages
  mktemp list_pkg || return "$ERR_CREAT_TMP"

  #get a list of all files and symlinks for given packages
  {
    files=("$ADM_DIR"/packages/@($glob))
    if ((${#files[@]})) ; then
      metaget -f "${files[@]}" || return 1
    fi
    files=("$ADM_DIR"/scripts/@($glob))
    if ((${#files[@]})) ; then
      doinstxlinks "${files[@]}" || return 1
    fi
  } | sort -u > "$list_pkg" || return "$ERR_META_FETCH_FILE_LIST"

  #output files unique to the packages
  comm -23 "$list_pkg" "$list_others" || return "$ERR_META_FETCH_FILE_LIST"

  #store list of non-unique files not removed
  mktemp _removepkg_file_list_common || return "$ERR_CREAT_TMP"
  comm -12 "$list_pkg" "$list_others" > "$_removepkg_file_list_common" ||
  return "$ERR_META_FETCH_FILE_LIST"

  #remove temporary files other than that containing common files
  #that should be cleaned by a call to removepkg_file_list_common
  rm -f "$list_pkg" "$list_others"
} 2>/dev/null

removepkg_file_list_common() {
  cat "$_removepkg_file_list_common"
  rm -f "$_removepkg_file_list_common"
  _removepkg_file_list_common=
} 2>/dev/null
