#       Copyright 2010 Anshul Narula aka sunny <sunny_delhi18@yahoo.com>
#
#       This file is part of zenpakt

#       Zenpakt is free software; you can redistribute it and/or modify
#       it under the terms of the GNU General Public License as published by
#       the Free Software Foundation; either version 2 of the License, or
#       (at your option) any later version.
#
#       This program is distributed in the hope that it will be useful,
#       but WITHOUT ANY WARRANTY; without even the implied warranty of
#       MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#       GNU General Public License for more details.
#
#       You should have received a copy of the GNU General Public License
#       along with this program; if not, write to the Free Software
#       Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston,
#       MA 02110-1301, USA.

$$
upgradepkg_cleanup() {
  rm -rf "$ROOT/install"

  if ((PARANOID)) && [[ $MODE != warn ]] ; then
    local state
    if upgradepkg_state state ; then
      case $state in
        upgrade)
          if upgradepkg_move_db_tmp_state ; then

            if installpkg_bkup_exists ; then
              local basename
              upgradepkg_state_basename basename

              if [[ $basename ]] ; then
                removepkg_bkup_restore
                #if database was written but installation was not done:
                #We move the database to the partial_packages directory
                if [[ -e $ADM_DIR/packages/$basename ]] ; then
                  mv "$ADM_DIR/"{,partial_}packages/"$basename"

                #If database was not written but temporary file was created, move it
                #to partial database, if that fails just create an empty database file
                #with no content only if a file doesnot already exist in the partial
                #database, there is a chance that we actually called installpkg_install
                #which failed and we called installpkg_move_db_partial which succeeded
                #but didnot yet restore from the backup while we were interrupted.
                elif ! installpkg_move_db_partial "$basename" ; then
                  [[ -e "$ADM_DIR/partial_packages/$basename" ]] ||
                  > "$ADM_DIR/partial_packages/$basename"
                fi

                #remove the doinst script if its there
                rm -f "$ADM_DIR/scripts/$basename"
              fi

              installpkg_bkup_restore
            fi

            upgradepkg_unmove_db
          fi
          ;;

        install)
          installpkg_cleanup
          return
          ;;
      esac
    fi
  fi

  meta_rm_tmpdir

  #if last set exit status is lock failure, we do not remove lock
  local exitstatus
  error_exit_status exitstatus
  ((exitstatus == ERR_LOCKED)) || lock -r
}
