#       Copyright 2011 Anshul Narula aka sunny <sunny_delhi18@yahoo.com>
#
#       This file is part of zenpakt

#       Zenpakt is free software; you can redistribute it and/or modify
#       it under the terms of the GNU General Public License as published by
#       the Free Software Foundation; either version 2 of the License, or
#       (at your option) any later version.
#
#       This program is distributed in the hope that it will be useful,
#       but WITHOUT ANY WARRANTY; without even the implied warranty of
#       MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#       GNU General Public License for more details.
#
#       You should have received a copy of the GNU General Public License
#       along with this program; if not, write to the Free Software
#       Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston,
#       MA 02110-1301, USA.

$DOC

========================
 upgradepkg_divide_name
========================

SYNOPSIS
--------

upgradepkg_divide_name pattern package_to_install package_to_remove

DESCRIPTION
-----------

It cuts the pattern into two based on UPGRADEPKG_FS, if UPGRADEPKG_FS is not
null.If UPGRADEPKG_FS forms the end of the pattern and is not present more than
once in the pattern, there is no package to be installed and therefore
ERR_UPGRADE_NO_PKG is returned.Otherwise, the pattern is split into two at the
first occurence of UPGRADEPKG_FS.The second part is stored in variable
package_to_install and the first in package_to_remove.

If UPGRADEPKG_FS is null or UPGRADEPKG_FS is not part of the pattern, the entire
pattern is taken as name of package to be installed and is stored in
package_to_install.package_to_remove is set to null value.

$ENDDOC

$$

upgradepkg_divide_name() {

  if [[ $UPGRADEPKG_FS && $1 = *"$UPGRADEPKG_FS"* ]] ; then
    [[ $1 = *"$UPGRADEPKG_FS" && $1 != *"$UPGRADEPKG_FS"*"$UPGRADEPKG_FS" ]] &&
    return "$ERR_UPGRADE_NO_PKG"

    printf -v "$2" '%s' "${1#*$UPGRADEPKG_FS}"
    printf -v "$3" '%s' "${1%%$UPGRADEPKG_FS*}"

  else
    printf -v "$2" '%s' "${1#*$UPGRADEPKG_FS}"
    printf -v "$3" '%s'
  fi
}
